Package org.apache.lucene.spatial3d.geom

# Class GeoBaseCompositeShape<T extends GeoShape>

java.lang.Object
org.apache.lucene.spatial3d.geom.BasePlanetObject
org.apache.lucene.spatial3d.geom.GeoBaseCompositeShape<T>

Type Parameters:
  `T` - is the type of GeoShapes of the composite.

All Implemented Interfaces:
  `Bounded`, `GeoBounds`, `GeoShape`, `Membership`, `PlanetObject`, `SerializableObject`

Direct Known Subclasses:
  `GeoCompositeAreaShape`, `GeoCompositeMembershipShape`, `GeoCompositePolygon`

public abstract class GeoBaseCompositeShape<T extends GeoShape> extends BasePlanetObject implements GeoShape
Base class to create a composite of GeoShapes.

WARNING: This API is experimental and might change in incompatible ways in the next release.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final List<T>`
`shapes`
Shape's container

### Fields inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

`planetModel`

## Constructor Summary

Constructors
Constructor
Description
`GeoBaseCompositeShape(PlanetModel planetModel)`
Constructor.
`GeoBaseCompositeShape(PlanetModel planetModel, InputStream inputStream, Class<T> clazz)`
Constructor for deserialization.

## Method Summary

Modifier and Type
Method
Description
`void`
`addShape(T shape)`
Add a shape to the composite.
`boolean`
`equals(Object o)`
`void`
`getBounds(Bounds bounds)`
Compute bounds for the shape.
`GeoPoint[]`
`getEdgePoints()`
Return a sample point that is on the outside edge/boundary of the shape.
`T`
`getShape(int index)`
Get shape at index
`List<T>`
`getShapes()`
Returns an unmodifiable list of composed shapes.
`int`
`hashCode()`
`boolean`
`intersects(Plane p, GeoPoint[] notablePoints, Membership... bounds)`
Assess whether a plane, within the provided bounds, intersects with the shape's edges.
`boolean`
`isWithin(double x, double y, double z)`
Check if a point is within this shape.
`boolean`
`isWithin(Vector point)`
Check if a point is within this shape.
`int`
`size()`
Get the number of shapes in the composite
`void`
`write(OutputStream outputStream)`
Serialize to output stream.

### Methods inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

`getPlanetModel`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.lucene.spatial3d.geom.PlanetObject

`getPlanetModel`

## Field Details

### shapes

protected final List<T extends GeoShape> shapes
Shape's container

## Constructor Details

### GeoBaseCompositeShape

public GeoBaseCompositeShape(PlanetModel planetModel)
Constructor.

### GeoBaseCompositeShape

public GeoBaseCompositeShape(PlanetModel planetModel, InputStream inputStream, Class<T> clazz) throws IOException
Constructor for deserialization.

Parameters:
  `planetModel` - is the planet model.
  `inputStream` - is the input stream.
  `clazz` - is the class of the generic.
Throws:
  `IOException`

## Method Details

### addShape

public void addShape(T shape)
Add a shape to the composite.

Parameters:
  `shape` - is the shape to add.

### size

public int size()
Get the number of shapes in the composite

Returns:
  the number of shapes

### getShape

public T getShape(int index)
Get shape at index

Returns:
  the shape at given index

### write

public void write(OutputStream outputStream) throws IOException
Description copied from interface: `SerializableObject`
Serialize to output stream.

Specified by:
  `write` in interface `SerializableObject`
Overrides:
  `write` in class `BasePlanetObject`
Parameters:
  `outputStream` - is the output stream to write to.
Throws:
  `IOException`

### isWithin

public boolean isWithin(Vector point)
Description copied from interface: `Membership`
Check if a point is within this shape.

Specified by:
  `isWithin` in interface `Membership`
Parameters:
  `point` - is the point to check.
Returns:
  true if the point is within this shape

### isWithin

public boolean isWithin(double x, double y, double z)
Description copied from interface: `Membership`
Check if a point is within this shape.

Specified by:
  `isWithin` in interface `Membership`
Parameters:
  `x` - is x coordinate of point to check.
  `y` - is y coordinate of point to check.
  `z` - is z coordinate of point to check.
Returns:
  true if the point is within this shape

### getEdgePoints

public GeoPoint[] getEdgePoints()
Description copied from interface: `GeoShape`
Return a sample point that is on the outside edge/boundary of the shape.

Specified by:
  `getEdgePoints` in interface `GeoShape`
Returns:
  samples of all edge points from distinct edge sections. Typically one point is returned, but zero or two are also possible.

### intersects

public boolean intersects(Plane p, GeoPoint[] notablePoints, Membership... bounds)
Description copied from interface: `GeoShape`
Assess whether a plane, within the provided bounds, intersects with the shape's edges. Any overlap, even a single point, is considered to be an intersection. Note well that this method is allowed to return "true" if there are internal edges of a composite shape which intersect the plane. Doing this can cause getRelationship() for most GeoBBox shapes to return OVERLAPS rather than the more correct CONTAINS, but that cannot be helped for some complex shapes that are built out of overlapping parts.

Specified by:
  `intersects` in interface `GeoShape`
Parameters:
  `p` - is the plane to assess for intersection with the shape's edges or bounding curves.
  `notablePoints` - represents the intersections of the plane with the supplied bounds. These are used to disambiguate when two planes are identical and it needs to be determined whether any points exist that fulfill all the bounds.
  `bounds` - are a set of bounds that define an area that an intersection must be within in order to qualify (provided by a GeoArea).
Returns:
  true if there's such an intersection, false if not.

### getBounds

public void getBounds(Bounds bounds)
Description copied from interface: `Bounded`
Compute bounds for the shape.

Specified by:
  `getBounds` in interface `Bounded`
Parameters:
  `bounds` - is the input bounds object. The input object will be modified.

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `BasePlanetObject`

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `BasePlanetObject`

### getShapes

public List<T> getShapes()
Returns an unmodifiable list of composed shapes.